// #name = AOH Capture the Flag Stuff
// #category = Advanced Objective HUD
// #version = 1.0
// #author = Grinder
// #date = August 27, 2001
// #credit = Crunchy
// #description = Includes DroppedTimer and CTF Color Changes, aswell as
//                the MatchResult Indicator.

// Set to true if you play in TheLadder for extra Score Limit Rule
$ObjectiveHUD::LadderScore = false;

package ObjectiveCTF
{

function ObjectiveHUDCheckCTFScore(%schedule)
{
   %team1 = getManagerTeamId();
   if(%team1 == 1)
      %team2 = 2;
   else if(%team1 == 2)
      %team2 = 1;

   ObjectiveHud.teamName[%team1].profile = "ObjectiveHUDGreen";
   ObjectiveHud.teamName[%team2].profile = "objectiveHUDRed";

   if(Objective::getGametype() $= "CapturetheFlag")
   {

   %team1 = ObjectiveHud.teamScore[1].getValue();
   %team2 = ObjectiveHud.teamScore[2].getValue();
   //echo("Score: " @ %team1 @ ":" @ %team2);

   if($ObjectiveHUD::LadderScore)
   {
     if((%team1 - %team2) > 4) {

        if(getManagerTeamId() == 1) {
          ObjectiveHUDChangeFlagLabel("win");
        } else {
          ObjectiveHUDChangeFlagLabel("lose");
        }
     }
     else if((%team2 - %team1) > 4) {

        if(getManagerTeamId() == 2) {
          ObjectiveHUDChangeFlagLabel("win");
        } else {
          ObjectiveHUDChangeFlagLabel("lose");
        }
     }
     else if(abs(%team1 - %team2) < 5) {

          ObjectiveHUDChangeFlagLabel("draw");
     }
   } else {
   
     if(%team1 > %team2) {

        if(getManagerTeamId() $= 1) {
          ObjectiveHUDChangeFlagLabel("win");
        } else {
          ObjectiveHUDChangeFlagLabel("lose");
        }
     }
     else if(%team1 < %team2) {

        if(getManagerTeamId() $= 2) {
          ObjectiveHUDChangeFlagLabel("win");
        } else {
          ObjectiveHUDChangeFlagLabel("lose");
        }
     }
     else if(%team1 == %team2) {

          ObjectiveHUDChangeFlagLabel("draw");
     }
   }

   // has some calc errors if the schedule isnt implemented
   // score seems to be updated after this function is executed
   if(!%schedule)
     Schedule(200, 0, ObjectiveHUDCheckCTFScore, 1);

   }
}

function ObjectiveHUDChangeFlagLabel(%res)
{
   if(%res $= "win")  {

        ObjectiveHud.mapInfo[2].profile = "ObjectiveHUDGreen";
        ObjectiveHud.mapInfo[2].setValue("Your team WINS.");
   }
   if(%res $= "lose") {

        ObjectiveHud.mapInfo[2].profile = "ObjectiveHUDRed";
        ObjectiveHud.mapInfo[2].setValue("Your team LOSES.");
   }
   if(%res $= "draw") {

        ObjectiveHud.mapInfo[2].profile = "ObjectiveHUDYellow";
        ObjectiveHud.mapInfo[2].setValue("Match is DRAW.");
   }
}

function ObjectiveHUDDroppedTimer(%index, %time)
{
    if($DroppedTimer[%index]) {

       if(%time == 0)
       {
         objectiveHud.flagLocation[%index].setValue("<At Base>");
         return;
       }

       %time--;
       objectiveHud.flagLocation[%index].profile = "ObjectiveHUDYellow";
   	   objectiveHud.flagLocation[%index].setValue("<Dropped: " @ %time @ ">");
       schedule(1000, 0, ObjectiveHUDDroppedTimer, %index, %time);
    }
}

function ObjectiveHUD::DroppedTimerCancel(%index)
{
    $DroppedTimer[%index] = false;
}


function ctfFlagDropped(%msgType, %msgString, %a1, %a2, %a3, %a4, %a5, %a6)
{
   	%index = detag(%a3);

    $DroppedTimer[%index] = true;
	  	ObjectiveHUDDroppedTimer(%index, 46);
    ObjectiveHud.flagLocation[%index].profile = "ObjectiveHUDYellow";
}

function ctfFlagTaken(%msgType, %msgString, %a1, %a2, %a3, %a4, %a5, %a6)
{
   	%index = detag(%a3);
  		%taker = detag(%a4);

		  ObjectiveHUD::DroppedTimerCancel(%index);
  		objectiveHud.flagLocation[%index].setValue(%taker);

    ObjectiveHUDCheckCTFScore();
    
   %clTeam = getManagerTeamId();

   if(%index == %clTeam) objectiveHud.flagLocation[%index].profile = "ObjectiveHUDGreen";
   else objectiveHud.flagLocation[%index].profile = "GuiTextObjHudLeftProfile";
}

function ctfFlagReturned(%msgType, %msgString, %a1, %a2, %a3, %a4, %a5, %a6)
{
  		ObjectiveHUD::DroppedTimerCancel(detag(%a3));

		  %index = detag(%a3);

  		ObjectiveHUD::DroppedTimerCancel(%index);
		  objectiveHud.flagLocation[%index].setValue("<At Base>");
    
   %clTeam = getManagerTeamId();
      
   if(%index == %clTeam) objectiveHud.flagLocation[%index].profile = "ObjectiveHUDGreen";
   else objectiveHud.flagLocation[%index].profile = "GuiTextObjHudLeftProfile";
}

function ObjectiveHUDClientJoinTeam(%msgType, %msgString, %clientName, %teamName, %clientId, %teamId)
{
   if(%clientId $= getManagerId())
      ObjectiveHUDCheckCTFScore();
}

function ObjectiveHUDSetDefault()
{
   $DroppedTimer[1] = false;
   $DroppedTimer[2] = false;
   objectiveHud.flagLocation[1].setValue("<At Base>");
   objectiveHud.flagLocation[2].setValue("<At Base>");
   objectiveHudChangeFlagLabel("DRAW");
}

function DispatchLaunchMode()
{
   addMessageCallback('MsgClientJoinTeam', ObjectiveHUDClientJoinTeam);
   addMessageCallback('MsgCTFFlagCapped', ObjectiveHUDCheckCTFScore);
   addMessageCallback('MsgClearObjHud', ObjectiveHUDSetDefault);
   addMessageCallback('MsgMissionStart', ObjectiveHUDCheckCTFScore);

   parent::DispatchLaunchMode();
}

};

activatePackage(ObjectiveCTF);
