// #name = AOH Capture and Hold Stuff
// #category = Advanced Objective Hud
// #version = 1.0
// #author = Grinder
// #date = August 27, 2001

package ObjectiveHUDCnH
{

function ObjectiveHud::addCnHObjective(%index)
{
    %total = Objective::getCount();
    
    for(%i = 1; %i <= %total; %i++) {
    
      %name = Objective::getName(%i);
      ObjectiveHud.objectInfo[%i].setValue(%name);
    }
}

function ObjectiveHudCnHFlip(%msgType, %msgString, %taker, %objective, %team)
{
  for(%i = 1; %i <= Objective::getCount(); %i++) {
  
     //echo("ObjectiveFlip " @ %i @ ": For Team: " @ detag(%team) @ " Your team: " @ getManagerTeam());
     //echo("Objective: DB Name: " @ Objective::getName(%i) @ " This Obj: " @ detag(%objective));
     if(Objective::getName(%i) $= StripSpace(detag(%objective))) {
     
       if(getManagerTeam() $= detag(%team)) {
       
         objectiveHud.ObjectInfo[%i].profile = "ObjectiveHUDGreen";
       } else {
       
         objectiveHud.ObjectInfo[%i].profile = "ObjectiveHUDRed";
       }
     }
  }
}

function ObjectiveHudCnHChangeTeam(%msgType, %msgString, %clientName, %teamName, %clientId, %teamId)
{
   if(Objective::getGametype() !$= "CaptureandHold")
      return;

   if(getManagerId() $= %clientId) {
   
      for(%i = 1; %i <= Objective::getCount(); %i++) {
      
         //echo("Objective DB Team: " @ Objective::Flip2Team(Objective::getName(%i)) @ " own Team: " @ detag(%teamName));
         if(Objective::Flip2Team(Objective::getName(%i)) $= detag(%teamName)) {
         
            objectiveHud.ObjectInfo[%i].profile = "ObjectiveHUDGreen";
         } else {
         
           if(Objective::Flip2Team(Objective::getName(%i)) !$= "")
           
            objectiveHud.ObjectInfo[%i].profile = "ObjectiveHUDRed";
         }
      }
   }
   
   ObjectiveHudCalcScoreCnH();
}

function ObjectiveHudCalcSCoreCnH()
{
   %team1 = getManagerTeamId();
   if(%team1 == 1)
      %team2 = 2;
   else if(%team1 == 2)
      %team2 = 1;

   ObjectiveHud.teamName[%team1].profile = "ObjectiveHUDGreen";
   ObjectiveHud.teamName[%team2].profile = "objectiveHUDRed";
   
   if(Objective::getGametype() $= "CaptureandHold") {

     %score1 = ObjectiveHud.teamScore[1].getValue();
     %score2 = ObjectiveHud.teamScore[2].getValue();
     %score1 = getSubStr(%score1, 0, strlen(%score1)-5);
     %score2 = getSubStr(%score2, 0, strlen(%score2)-5);
     
   if(%score1 > %score2) {

      if(getManagerTeamId() $= 1) {
        ObjectiveHUDChangeHoldLabel("win");
      } else {
        ObjectiveHUDChangeHoldLabel("lose");
      }
   }
   else if(%score1 < %score2) {

      if(getManagerTeamId() $= 2) {
        ObjectiveHUDChangeHoldLabel("win");
      } else {
        ObjectiveHUDChangeHoldLabel("lose");
      }
   }
   else if(%score1 $= %score2) {

        ObjectiveHUDChangeHoldLabel("draw");
   }
  }
  
  schedule(1000, 0, ObjectiveHUDCalcScoreCnH);
}

function ObjectiveHUDChangeHoldLabel(%res)
{
   if(%res $= "win")  {

        ObjectiveHud.holdLabel[1].profile = "ObjectiveHUDGreenCenter";
        ObjectiveHud.holdLabel[2].profile = "ObjectiveHUDGreenCenter";
        ObjectiveHud.holdLabel[1].setValue("You:");
        ObjectiveHud.holdLabel[2].setValue("WIN");
   }
   if(%res $= "lose") {

        ObjectiveHud.holdLabel[1].profile = "ObjectiveHUDRedCenter";
        ObjectiveHud.holdLabel[2].profile = "ObjectiveHUDRedCenter";
        ObjectiveHud.holdLabel[1].setValue("You:");
        ObjectiveHud.holdLabel[2].setValue("LOSE");
   }
   if(%res $= "draw") {

        ObjectiveHud.holdLabel[1].profile = "ObjectiveHUDYellowCenter";
        ObjectiveHud.holdLabel[2].profile = "ObjectiveHUDYellowCenter";
        ObjectiveHud.holdLabel[1].setValue("Match:");
        ObjectiveHud.holdLabel[2].setValue("DRAW");
   }
}

function DispatchLaunchMode()
{
  //addMessageCallback('MsgClientJoin', ObjectiveHudCnHJoin);
  addMessageCallback('MsgClaimFlipFlop', ObjectiveHudCnHFlip);
  addMessageCallback('MsgClientJoinTeam', ObjectiveHudCnHChangeTeam);
  
  parent::DispatchLaunchMode();
}

};

activatePackage(ObjectiveHUDCnH);
