// #name = Advanced Objective HUD
// #category = Advanced Objective HUD
// #version = 1.0
// #author = Grinder
// #date = August 27, 2001
// #description = Main Code of Objective HUD
// #name = ObjectiveHUD
// #web = http://www.planettribes.com/grinder
// #email = Grinder@planettribes.com
// #warrior = TriBaLGriNdeR

$ObjectiveHUD::MoreInfo = true;

package AdvancedObjectiveHud
{

function getscorestuff()
{
	for ( %line = 0; LobbyGui.objLine[%line] !$= ""; %line++ )
	{
		if(StrStr(LobbyGui.objLine[%line], "points") != -1)
		{	
			%pos1 = strStr(LobbyGui.objLine[%line], "points");
			$TheMissionScore = getSubStr(LobbyGui.objLine[%line], 0, %pos1);
			echo("Mission Score = "@$TheMissionScore);
			return $TheMissionScore;
		}
	}
}


function setupObjHud(%gameType)
{
 parent::setupObjHud(%gametype);
 
 if((%gametype $= "CTFGame") && ($ObjectiveHUD::CTF::MoreInfo $= "false"))
   return;
   
 if((%gametype $= "CnHGame") && ($ObjectiveHUD::CTF::MoreInfo $= "false"))
   return;

 switch$ (%gameType)
	{
		case CTFGame:
  
   			objectiveHud.extent = "345 37";
			objectiveHud.setSeparators("72 97 130 245");

   			// Map Info
			objectiveHud.mapInfo[1] = new GuiTextCtrl() {
				profile = "GuiTextObjHudLeftProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "248 3";
				extent = "95 16";
				visible = "1";
			};
			objectiveHud.mapInfo[2] = new GuiTextCtrl() {
				profile = "GuiTextObjHudLeftProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "248 19";
				extent = "95 16";
				visible = "1";
			};

   			objectiveHud.add(objectiveHud.mapInfo[1]);
   			objectiveHud.add(objectiveHud.mapInfo[2]);

   			objectiveHud.mapInfo[1].setValue("Score Limit: " @ getscorestuff());
   
		case HuntersGame:
   			objectiveHud.extent = "245 37";
			objectiveHud.setSeparators("96 132 209");
			objectiveHud.disableHorzSeparator();
			// worth label ("WORTH")
			objectiveHud.worthLabel = new GuiTextCtrl() {
				profile = "GuiTextObjGreenLeftProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "138 19";
				extent = "70 16";
				visible = "1";
				text = "WORTH";
			};
			// worth of flags
			objectiveHud.worthValue = new GuiTextCtrl() {
				profile = "GuiTextObjGreenCenterProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "212 19";
				extent = "30 16";
				visible = "1";
			};
			objectiveHud.add(objectiveHud.worthLabel);
			objectiveHud.add(objectiveHud.worthValue);

		case TeamHuntersGame:
   			objectiveHud.extent = "245 37";
			objectiveHud.setSeparators("43 87 88 89 161 203 204 205");

			// "WORTH" label
			objectiveHud.worthLabel = new GuiTextCtrl() {
				profile = "GuiTextObjGreenLeftProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "4 19";
				extent = "38 16";
				visible = "1";
				text = "WORTH";
			};
			// worth of flags
			objectiveHud.worthValue = new GuiTextCtrl() {
				profile = "GuiTextObjGreenCenterProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "44 19";
				extent = "44 16";
				visible = "1";
			};

			// "NEED" label
			objectiveHud.flagsNeededLabel = new GuiTextCtrl() {
				profile = "GuiTextObjGreenCenterProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "209 3";
				extent = "32 16";
				visible = "1";
				text = "NEED";
			};

			// Flags the losing team needs to cap - to tie or beat
			objectiveHud.flagsNeededValue = new GuiTextCtrl() {
				profile = "ObjectiveHUDHUDGreenCenter";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "209 19";
				extent = "32 16";
				visible = "1";
			};

			objectiveHud.flagLabel.position = "4 3";
			objectiveHud.flagLabel.extent = "38 16";

			objectiveHud.yourFlags.position = "44 3";
			objectiveHud.yourFlags.extent = "44 16";

			objectiveHud.teamName[1].position = "94 3";
			objectiveHud.teamName[1].extent = "62 16";

			objectiveHud.teamName[2].position = "94 19";
			objectiveHud.teamName[2].extent = "62 16";

			objectiveHud.teamScore[1].position = "163 3";
			objectiveHud.teamScore[2].position = "163 19";

			objectiveHud.add(objectiveHud.worthLabel);
			objectiveHud.add(objectiveHud.worthValue);
			objectiveHud.add(objectiveHud.flagsNeededLabel);
			objectiveHud.add(objectiveHud.flagsNeededValue);

			$HuntersHUD::flags = 0;
			$HuntersHUD::score[1] = 0;
			$HuntersHUD::score[2] = 0;

			objectiveHud.flagsNeededValue.setValue(0);
   
  		case CnHGame:
   			objectiveHud.extent = "405 37";
			objectiveHud.setSeparators("96 162 202 225 285 345");
   
			objectiveHud.ObjectInfo[1] = new GuiTextCtrl() {
				profile = "GuiTextObjHudLeftProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "228 3";
				extent = "86 16";
				visible = "1";
			};
			objectiveHud.ObjectInfo[2] = new GuiTextCtrl() {
				profile = "GuiTextObjHudLeftProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "228 19";
				extent = "86 16";
				visible = "1";
			};
			objectiveHud.ObjectInfo[3] = new GuiTextCtrl() {
				profile = "GuiTextObjHudLeftProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "288 3";
				extent = "86 16";
				visible = "1";
			};
			objectiveHud.ObjectInfo[4] = new GuiTextCtrl() {
				profile = "GuiTextObjHudLeftProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "288 19";
				extent = "86 16";
				visible = "1";
			};
			objectiveHud.ObjectInfo[5] = new GuiTextCtrl() {
				profile = "GuiTextObjHudLeftProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "348 3";
				extent = "86 16";
				visible = "1";
			};
			objectiveHud.ObjectInfo[6] = new GuiTextCtrl() {
				profile = "GuiTextObjHudLeftProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "348 19";
				extent = "86 16";
				visible = "1";
			};
   
   for(%i = 1; %i <= 6; %i++) {
   
     objectiveHud.add(ObjectiveHud.ObjectInfo[%i]);
     objectiveHud::addCnHObjective(%i);
   }

  case DMGame:
   objectiveHud.extent = "245 37";
 }
}

};

activatePackage(AdvancedObjectiveHUD);

// Fonts and Profiles
new GuiControlProfile ("ObjectiveHUDRedCenter")
{
	fontType = "Univers Condensed";
	fontSize = 16;
	fontColor = "255 0 0";
   fontColors[6] = $PlayerNameColor;
   fontColors[7] = $TribeTagColor;
   fontColors[8] = $SmurfNameColor;
   fontColors[9] = $BotNameColor;
	justify = "center";
};

new GuiControlProfile ("ObjectiveHUDGreenCenter")
{
	fontType = "Univers Condensed";
	fontSize = 16;
	fontColor = "23 236 67";
   fontColors[6] = $PlayerNameColor;
   fontColors[7] = $TribeTagColor;
   fontColors[8] = $SmurfNameColor;
   fontColors[9] = $BotNameColor;
	justify = "center";
};

new GuiControlProfile ("ObjectiveHUDYellowCenter")
{
	fontType = "Univers Condensed";
	fontSize = 16;
	fontColor = "255 205 0";
   fontColors[6] = $PlayerNameColor;
   fontColors[7] = $TribeTagColor;
   fontColors[8] = $SmurfNameColor;
   fontColors[9] = $BotNameColor;
	justify = "center";
};

new GuiControlProfile ("ObjectiveHUDRed")
{
	fontType = "Univers Condensed";
	fontSize = 16;
	fontColor = "255 0 0";
   fontColors[6] = $PlayerNameColor;
   fontColors[7] = $TribeTagColor;
   fontColors[8] = $SmurfNameColor;
   fontColors[9] = $BotNameColor;
};

new GuiControlProfile ("ObjectiveHUDgreen")
{
	fontType = "Univers Condensed";
	fontSize = 16;
	fontColor = "23 236 67";
   fontColors[6] = $PlayerNameColor;
   fontColors[7] = $TribeTagColor;
   fontColors[8] = $SmurfNameColor;
   fontColors[9] = $BotNameColor;
};

new GuiControlProfile ("ObjectiveHUDyellow")
{
	fontType = "Univers Condensed";
	fontSize = 16;
	fontColor = "255 205 0";
   fontColors[6] = $PlayerNameColor;
   fontColors[7] = $TribeTagColor;
   fontColors[8] = $SmurfNameColor;
   fontColors[9] = $BotNameColor;
};

new GuiControlProfile ("ObjectiveHUDwhite")
{
	fontType = "Univers Condensed";
	fontSize = 16;
	fontColor = "169 215 250";
   fontColors[6] = $PlayerNameColor;
   fontColors[7] = $TribeTagColor;
   fontColors[8] = $SmurfNameColor;
   fontColors[9] = $BotNameColor;
	justify = "center";
};
