// #name = AOH Hunters/TeamHunters Stuff
// #category = Advanced Objective HUD
// #version = 1.0
// #author = Grinder
// #date = August 27, 2001
// #description = Cowboys HuntersHUD code adatped to be used in Advanced
//                Objective HUD.
// #web = http://www.planettribes.com/grinder/
// #email = Grinder@planettribes.com
// #credit = Cowboy

package ObjectiveHUDHunters
{

function huntYouHaveFlags(%msgType, %msgString, %a1, %a2, %a3, %a4, %a5, %a6) {
	parent::huntYouHaveFlags(%msgType, %msgString, %a1, %a2, %a3, %a4, %a5, %a6);

	$HuntersHUD::yourFlags = detag(%a1);

	objectiveHud.worthValue.setValue(flagsToScore($HuntersHUD::yourFlags));

	UpdateTeamHunters();
}

function teamScoreIs(%msgType, %msgString, %a1, %a2, %a3, %a4, %a5, %a6) {
	parent::teamScoreIs(%msgType, %msgString, %a1, %a2, %a3, %a4, %a5, %a6);

	%teamNum = detag(%a1);
	%score = detag(%a2);

	if(%score $= "")
		%score = 0;

	$HuntersHUD::score[%teamNum] = %score;

	UpdateTeamHunters();
}

function ObjectiveHUDHuntersTeamChange(%msgType, %msgString, %clientName, %teamName, %clientId, %teamId) {

  if((getManagerId() $= %clientId) && (Objective::getGametype() $= "TeamHunters"))
	  	UpdateTeamHunters();
}

function UpdateTeamHunters() {

	if ($HuntersHUD::Type $= "TeamHuntersGame") {
		%t1 = $HuntersHUD::score[1];
		%t2 = $HuntersHUD::score[2];

		%diff = %t1 - %t2;
		%isneg = %diff == 0 ? 1 : %diff / abs(%diff);
		%isteam = %isneg == 1 ? 1 : 2;
		%toTie = flagsNeededToTie(abs(%diff));

		if (%isteam == getClientTeamId(getManagerId())) {
			objectiveHud.flagsNeededLabel.profile = "ObjectiveHUDwhite";
			objectiveHud.flagsNeededValue.profile = "ObjectiveHUDwhite";

			objectiveHud.flagLabel.profile = "ObjectiveHUDwhite";
			objectiveHud.yourFlags.profile = "ObjectiveHUDwhite";
			objectiveHud.worthLabel.profile = "ObjectiveHUDwhite";
			objectiveHud.worthValue.profile = "ObjectiveHUDwhite";
		}
		else if ($HuntersHUD::yourFlags >= %toTie) {
			objectiveHud.flagsNeededLabel.profile = "ObjectiveHUDgreen";
			objectiveHud.flagsNeededValue.profile = "ObjectiveHUDgreen";

			objectiveHud.flagLabel.profile = "ObjectiveHUDgreen";
			objectiveHud.yourFlags.profile = "ObjectiveHUDgreen";
			objectiveHud.worthLabel.profile = "ObjectiveHUDgreen";
			objectiveHud.worthValue.profile = "ObjectiveHUDgreen";
		}
		else {
			objectiveHud.flagsNeededLabel.profile = "ObjectiveHUDyellow";
			objectiveHud.flagsNeededValue.profile = "ObjectiveHUDyellow";

			objectiveHud.flagLabel.profile = "ObjectiveHUDyellow";
			objectiveHud.yourFlags.profile = "ObjectiveHUDyellow";
			objectiveHud.worthLabel.profile = "ObjectiveHUDyellow";
			objectiveHud.worthValue.profile = "ObjectiveHUDyellow";
		}

		objectiveHud.flagsNeededValue.setValue(%toTie);
	}
}


function flagsToScore(%flags) {
	return ((%flags + 1) * %flags / 2);
}

function scoreToFlags(%score) {
	return mFloor(mSqrt(%score * 2));
}

function flagsNeededToTie(%score) {
	%flags = scoreToFlags(%score);
	if (flagsToScore(%flags) < %score)
		%flags++;

	return %flags;
}

function DispatchLaunchMode()
{
   addMessageCallback('MsgCheckTeamLines', UpdateTeamHunters);
   addMessageCallback('MsgClientJoinTeam', ObjectiveHUDHuntersTeamChange);

   parent::DispatchLaunchMode();
}

};

activatePackage(ObjectiveHUDHunters);
