// #name = ObjectiveTrak
// #version = 1.0
// #status = some Trakking functions still needed
// #description = Traks Info about Score, Map and Gametypes, as well as over
//                all Objectives (mainly in Capture and Hold gametype).
// #author = Grinder
// #date = August 25, 2001
// #credit = Crunchy

package ObjectiveTrak
{

// General Objective Functions
//   Objective::getGametype()
//   Objective::getMap()
//   Objective::getTeamScore(%teamId)
//   Objective::getMapScoreLimit(%map)

function Objective::getGametype()
{
  return $Objective::CurrentGametype;
}

function Objective::getMap()
{
  return $Objective::CurrentMap;
}

function Objective::getTeamScore(%teamId)
{
  if(!%teamId)
    %teamId = 1;

  return ObjectiveHud.teamScore[%teamId].getValue();
}

function Objective::getMapScoreLimit(%map, %oldscore)
{
  if(!%map)
    %map = Objective::getMap();


  // Support for Leagues played with Original MapScore Limit
  if((%oldscore) && (Objective::getGametype() $= "CapturetheFlag"))
  {
    if(strlen($Objective::MapScoreLimit[%map]) $= 4)
      return getSubStr($Objective::MapScoreLimit[%map], 1, 2);
    else
      return getSubStr($Objective::MapScoreLimit[%map], 1, 1);
  }
  else
    return $Objective::MapScoreLimit[%map];
}

// Capture the flag functions
//   Objective::getFlagLocation(%teamId)

function Objective::getFlagLocation(%teamId)
{
  if(Objective::getGametype() $= "CapturetheFlag")
  {
    if(!%teamId)
      %teamId = 1;

    return ObjectiveHud.flagLocation[%teamId].getValue();
  }
  else
     error("ObjectiveTrak: Function Objective::getFlagLocation is only available in CTF matches.");
}

function Objective::getTeamGrabCount(%teamId)
{
  if(Objective::getGametype() $= "CapturetheFlag")
  {
    if(!%teamId)
       %teamId = 1;

    %grabs = getSubStr(Objective::getTeamScore(%teamId), 2, 2);
    if(getSubStr(%grabs, 1, 1) $= "0") {
  
      %grabs = getSubStr(%grabs, 2, 1);
       return %grabs;
    } else
      return %grabs;
  }
  else
     error("ObjectiveTrak: Function Objective::getTeamGrabCount is only available in CTF matches.");
}

// Capture and Hold functions
//   Objective::Flip2Team(%objective)
//   Objective::getCount(%map)
//   Objective::getName(%objectId, %map)
//   Objective::CalcScore4secs(%teamname, %time)

function Objective::Flip2Team(%objective)
{
   if(Objective::getGametype() $= "CaptureandHold")
     return $Objective::TempObj[%objective];
   else
     error("ObjectiveTrak: Function Objective::Flip2Team is only available in CnH matches.");
}

function Objective::getCount(%map)
{
   if(Objective::getGametype() $= "CaptureandHold")
   {
     if(!%map)
       %map = Objective::getMap();

     return $Objective::Count[%map];
   }
   else
     error("ObjectiveTrak: Function Objective::getCount is only available in CnH matches.");
}

function Objective::getName(%objectId, %map)
{
  if(Objective::getGametype() $= "CaptureandHold")
  {
    if(!%map)
      %map = Objective::getMap();
    
    return $Objective::Name[%map, %objectId];
  }
  else
     echo("ObjectiveTrak: Function Objective::getCount is only available in CnH matches.");
}
  
// Callbacks

function ObjectiveTrakMissionLoad(%msgType, %msgString, %bitmapName, %mapName, %missionType) {

  $Objective::CurrentGametype = StripSpace(%missionType);
  $Objective::CurrentMap = StripSpace(%mapName);
}

function ObjectiveCnHFlip(%msgType, %msgString, %taker, %objective, %team)
{
     %objective = StripSpace(%objective);
     %map = Objective::GetMap();
     $Objective::TempObj[%objective] = detag(%team);
}

function ObjectiveTeamCheck(%msgType, %msgString, %clientName, %teamName, %clientId, %teamId)
{
  if((%clientId $= getManagerId()) && ($ObjectiveHUD::MissionStarted))
  {
     for(%i = 1; %i <= 2; %i++) {
        $Objective::Team[%i] = ObjectiveHud.teamName[%i].getValue();
        $Objective::TeamId[$Objective::Team[%i]] = %i;
     }
  }
}

function DispatchLaunchMode()
{
  addMessageCallback('MsgLoadInfo', ObjectiveTrakMissionLoad);
  addMessageCallback('MsgClaimFlipFlop', ObjectiveCnHFlip);
  addMessageCallback('MsgClientJoinTeam', ObjectiveTeamCheck);

  parent::DispatchLaunchMode();
}
  
// Team functions
//   Objective::getTeam(%teamId)
//   Objective::getTeamId(%name)

function Objective::getTeam(%teamId)
{
   return $Objective::Team[%teamId];
}

function Objective::getTeamId(%name)
{
   return $Objective::TeamId[%name];
}

function StripSpace(%var) {

 	%name = "";

	 for (%i = 0; %i < Strlen(%var); %i++)
 	{
     if(getSubStr(%var, %i, 1) $= " ") { }
     else {

        %name = %name @ getSubStr(%var, %i, 1);
     }
  }

 	return %name;
}

};

activatePackage(ObjectiveTrak);
